/*****************************************************
Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>
// Declare your global variables here

void main(void)
{
char A,B,C,n;// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTD=0x00;
DDRD=0xFF;

n=0;
A=0b11111111;
B=0b11111111;
C=0b00111111;
while (1)
      {
        while(A>1)
        {
            PORTD=A;
            PORTB=B;
            PORTC=C;
            A=A<<n+1;
            delay_ms(3);
            PORTD=0;
            PORTB=0;
            PORTC=0;
            delay_ms(1);
        };
        n=0;
        while(A==0 && B>1)
              {
                PORTB=B;
                PORTC=C;
                B=B<<n+1;
                delay_ms(3);
                PORTB=0;
                PORTC=0;
                delay_ms(1);
               };
              n=0;
        while(C>0 && B==0)
              {
                PORTC=C;
                C=C<<n+1;
                delay_ms(3);
                PORTC=0;
                delay_ms(1);
                if(C==0){delay_ms(6);}
               };

       if(C==0)
       {
           n=0;
           A=0b11111111;
           B=0b11111111;
           C=0b11111111;
       }

      }
}
